<style scoped lang="less">
</style>

<template>
    
    <Layout>
        
        <Header id="header">
            <Menu mode="horizontal" active-name="1" @on-select="visitCity">
                <img class="layout-logo" src="../images/flatflow-logo.png" alt="FlatFlow Logo">
                
                <div class="layout-nav">
                    <Submenu name="cities">
                        <template slot="title">
                            {{ this.capitalizeFirstLetter(this.$route.params.cityId) }}
                        </template>
                        <MenuGroup title="Städte">
                            <MenuItem v-if="cities && cities.length" v-for="city of cities" :name="city.id">{{ capitalizeFirstLetter(city.id) }}</MenuItem>
                        </MenuGroup>
                    </Submenu>
                </div>
            </Menu>
        </Header>
        
        <Content>
            
            <Layout class="main-layout" :style="{ height: 'calc(100vh - 80px)' }">
            
                <Sider class="sider-filter" :style="{ height: 'calc(100vh - 80px)' }" :width="320" breakpoint="lg" collapsible :collapsed-width="0" :hide-trigger="true" v-model="filterCollapsed">
                    
                    <div class="sider-filter-wrapper">
                        
                        <div class="map-toggle">
                            <Switch style="margin-right: 10px;" v-model="mapVisible">
                                <Icon type="md-checkmark" slot="open"></Icon>
                                <Icon type="md-close" slot="close"></Icon>
                            </Switch>
                            <span>Karte anzeigen</span>
                        </div>
                        
                        <Collapse simple v-model="openFilters">
                            <Panel name="daysToLookBack">
                                <span class="heading">Alter der Wohnungsanzeigen</span>
                                <span class="description">Es werden alle {{ lookBackOptions[daysToLookBack].label }} angezeigt.</span>
                                <p slot="content">
                                    <Select @on-change="filterChange" v-model="daysToLookBack" style="width: 100%">
                                        <Option v-for="item in lookBackOptions" :value="item.value" :key="item.value">{{ item.label }}</Option>
                                    </Select>
                                </p>
                            </Panel>
                            
                            <Panel name="rooms">
                                <span class="heading"><Switch style="margin-right: 10px;" size="small" v-model="filter.rooms.active" @on-change="onFilterRoomsState"></Switch> Anzahl Zimmer</span>
                                <span class="description" v-if="filter.rooms.active">zwischen {{ filter.rooms.range[0] }} und {{ filter.rooms.range[1] }} Zimmer</span>
                                <span class="description" v-if="!filter.rooms.active">Zeige alle Wohnungen jeglicher Zimmeranzahl</span>
                                <p slot="content">
                                    <Slider @on-change="filterChange" steps :tip-format="formatRoomFilter" v-model="filter.rooms.range" :disabled="!filter.rooms.active" :min="1" :max="10" range></Slider>
                                </p>
                            </Panel>
                            
                            <Panel name="size">
                                <span class="heading"><Switch style="margin-right: 10px;" size="small" v-model="filter.size.active" @on-change="onFilterSizeState"></Switch> Wohnungsgröße</span>
                                <span class="description" v-if="filter.size.active">zwischen {{ filter.size.range[0] }} und {{ filter.size.range[1] }} Quadratmeter</span>
                                <span class="description" v-if="!filter.size.active">Zeige alle Wohnungen jeglicher Quadratmeter</span>
                                <p slot="content">
                                    <Slider @on-change="filterChange" :disabled="!filter.size.active" v-model="filter.size.range" :min="10" :max="150" range :tip-format="formatSizeFilter"></Slider>
                                </p>
                            </Panel>
                            
                            <Panel name="price">
                                <span class="heading"><Switch style="margin-right: 10px;" size="small" v-model="filter.price.active" @on-change="onFilterPriceState"></Switch> Preisspanne</span>
                                <span class="description" v-if="filter.price.active">zwischen {{ filter.price.range[0] }}€ und {{ filter.price.range[1] }}€</span>
                                <span class="description" v-if="!filter.price.active">Zeige alle Wohnungen jeglichen Preises</span>
                                <p slot="content">
                                    <Slider @on-change="filterChange" :disabled="!filter.price.active" show-tip="hover" v-model="filter.price.range" :min="100" :max="1300" range :tip-format="formatPriceFilter"></Slider>
                                </p>
                            </Panel>
                            
                            <Panel name="equipment">
                                <span class="heading">Ausstattung</span>
                                <span class="description">Küche, Balkon + {{ Object.keys(filter.features.main).length - 2 }} weitere</span>
                                <p slot="content">
                                    <Checkbox v-for="item in filter.features.main" size="large" v-model="item.active" :key="item.value" @on-change="filterChange">{{ item.label }}</Checkbox>
                                </p>
                            </Panel>
                            
                            <Panel name="apartmentCondition">
                                <span class="heading">Zustand der Wohnung</span>
                                <span class="description">Altbau, Neubau + {{ Object.keys(filter.features.buildingState).length - 2 }} weitere</span>
                                
                                <p slot="content">
                                    <Checkbox v-for="item in filter.features.buildingState" size="large" v-model="item.active" :key="item.value" @on-change="filterChange">{{ item.label }}</Checkbox>
                                </p>
                            </Panel>
                            
                            <Panel name="barrierfree">
                                <span class="heading">Barrierefreiheit</span>
                                <span class="description">Barrierefrei, Rollstuhlgerecht + {{ Object.keys(filter.features.accessibility).length - 2 }} weitere</span>
                                
                                <p slot="content">
                                    <Checkbox v-for="item in filter.features.accessibility" size="large" v-model="item.active" :key="item.value" @on-change="filterChange">{{ item.label }}</Checkbox>                                   
                                </p>
                            </Panel>
                            
                            <Panel name="pets">
                                <span class="heading">Haustiere</span>
                                <span class="description">Wohnungsanzeigen, die Haustiere in der Beschreibung erwähnt haben.</span>
                                
                                <p slot="content">
                                    <Switch style="margin-right: 10px;" size="small" v-model="filter.features.pets.active" @on-change="filterChange"></Switch>
                                    <span>{{ filter.features.pets.label }}</span>
                                </p>
                            </Panel>
                            
                            <Panel name="wg">
                                <span class="heading">Wohngemeinschaften</span>
                                <span class="description">Wohnungsanzeigen, die WG-geeignet sind.</span>
                                
                                <p slot="content">
                                    <Switch style="margin-right: 10px;" size="small" v-model="filter.features.flatSharingSuitable.active" @on-change="filterChange"></Switch>
                                    <span>{{ filter.features.flatSharingSuitable.label }}</span>
                                </p>
                            </Panel>
                            
                        </Collapse>
                        
                        <Button @click="resetFilter" :disabled="!isFilterActive">Filter zurücksetzen</Button>
                    
                    </div>
                    
                </Sider>
                
                <Content class="content" style="height: calc(100vh - 80px);">
                
                    <h1 v-if="apartments && apartments.length">Alle {{pages.total}} {{ lookBackOptions[daysToLookBack].label }} in {{ $route.params.cityId }} <span v-if="filter.rooms.active">mit {{ filter.rooms.range[0] }} bis {{ filter.rooms.range[1] }} Zimmern</span> <span v-if="filter.size.active">zwischen {{ filter.size.range[0] }} bis {{ filter.size.range[1] }} Quadratmetern</span> <span v-if="filter.price.active">für {{ filter.price.range[0] }} bis {{ filter.price.range[1] }} Euro kalt</span></h1>
                    
                    <h1 v-else>Es wurden keine Wohnungsanzeigen gefunden</h1>
                    
                    <Result v-if="apartments && apartments.length" v-for="apartment of apartments" :apartment="apartment"/>
                        
                    <Alert show-icon v-if="pages.current == Math.ceil(parseFloat(pages.total / pages.size))" style="margin-bottom: 20px;">
                        Ende der Liste
                        <Icon type="ios-bulb-outline" slot="icon"></Icon>
                        <template slot="desc">
                            Das waren alle {{ lookBackOptions[daysToLookBack].label }} für {{ $route.params.cityId }}.
                            
                            <span style="display: block;" v-if="daysToLookBack !== 31">Hier muss deine Suche aber nicht aufhören. Klicke hier um die {{ lookBackOptions[nextKey(lookBackOptions, daysToLookBack)].label }} zu sehen.</span>
                        </template>
                    </Alert>
                
                    <Page @on-change="pageChange"
                          @on-page-size-change="pageSizeChage"
                          :page-size="pages.size"
                          :page-size-opts="[10, 20, 30, 40]"
                          :current="pages.current"
                          :total="pages.total"
                          show-sizer
                          :transfer="false" v-if="apartments && apartments.length"/>
                    
                </Content>
                
                <Sider class="sider-map" :width="300" :style="{ height: 'calc(100vh - 80px)' }" breakpoint="md" collapsible :collapsed-width="0" :hide-trigger="true" v-model="computedMapVisibility">
                
                    <GmapMap class="map" :center="map.options.center" :options="map.options">
                        
                        <gmap-custom-marker
                            v-if="apartment.location.lat && apartment.location.lng"
                            v-for="(apartment, index) in apartments"
                            :key="index"
                            :marker=" { latitude: parseFloat(apartment.location.lat), longitude: parseFloat(apartment.location.lng)}"
                            :clickable="true"
                            @click="center={lat: parseFloat(apartment.location.lat), lng: parseFloat(apartment.location.lng)}">
                            
                            <div v-if="apartment.location.houseNumber" class="marker">{{ apartment.price.cold }}€</div>
                            <div v-if="!apartment.location.houseNumber" class="radius">{{ apartment.price.cold }}€</div>
                            
                        </gmap-custom-marker>
                        
                    </GmapMap>
                        
                </Sider>
                
            </Layout>
            
        </Content>
        
    </Layout>
    
</template>

<script>
    import Vue from 'vue';
    import GmapCustomMarker from 'vue2-gmap-custom-marker';
    import * as VueGoogleMaps from 'vue2-google-maps';
    import VueLazyload from 'vue-lazyload';
    import axios from 'axios';
    import resultsData from './resultsData';
    import config from './../config/config';
    
    let some = require('lodash/some');
    let forEach = require('lodash/forEach');
    
    Vue.use(VueLazyload);
    
    Vue.use(VueGoogleMaps, {
        installComponents: true,
        load: {
            key: config.googleMapsApiKey,
        }
    });
    
    Vue.component('Result', require('./../components/result'));
    
    export default {
        components: {
            GmapCustomMarker
        },
        computed: {
            computedMapVisibility () {
                return !this.mapVisible;
            },
            isFilterActive () {
                let isFilterActive = false;
                
                // apply filter
                if (this.filter.rooms.active || this.filter.price.active || this.filter.size.active || this.filter.features.pets.active || this.filter.features.flatSharingSuitable.active) {
                    isFilterActive = true;
                }
                for (let property in this.filter.features.main) {
                    if (this.filter.features.main[property].active) {
                        isFilterActive = true;
                    }
                }
                for (let property in this.filter.features.buildingState) {
                    if (this.filter.features.buildingState[property].active) {
                        isFilterActive = true;
                    }
                }
                for (let property in this.filter.features.accessibility) {
                    if (this.filter.features.accessibility[property].active) {
                        isFilterActive = true;
                    }
                }
                
                return isFilterActive;
            }
        },
        data() {
            return resultsData;
        },
        methods: {
            onFilterRoomsState (isActive) {
                if (this.openFilters.includes('rooms') && isActive) {
                    event.stopPropagation();
                }
                
                this.$Notice.success({
                    title: 'Raumfilter ' + (isActive ? 'aktiviert' : 'deaktiviert'),
                    desc: 'Der Filter für die Anzahl Zimmer ist jetzt ' + (isActive ? 'aktiviert' : 'deaktiviert'),
                    duration: 8,
                    top: 100
                });
                
                this.fetchApartments();
            },
            onFilterPriceState (isActive) {
                if (this.openFilters.includes('price') && isActive) {
                    event.stopPropagation();
                }
                
                this.$Notice.success({
                    title: 'Preisfilter ' + (isActive ? 'aktiviert' : 'deaktiviert'),
                    desc: 'Der Filter für den Preis der Wohnungen ist jetzt ' + (isActive ? 'aktiviert' : 'deaktiviert'),
                    duration: 8,
                    top: 100
                });
                
                this.fetchApartments();
            },
            onFilterSizeState (isActive) {
                if (this.openFilters.includes('size') && isActive) {
                    event.stopPropagation();
                }
                
                this.$Notice.success({
                    title: 'Quadratmeterfilter ' + (isActive ? 'aktiviert' : 'deaktiviert'),
                    desc: 'Der Filter für die Quadratmeter der Wohnungen ist jetzt ' + (isActive ? 'aktiviert' : 'deaktiviert'),
                    duration: 8,
                    top: 100
                });
                
                this.fetchApartments();
            },
            nextKey (obj, key) {
                let keys = Object.keys(obj);
                let nextIndex = keys.indexOf(key.toString()) +1;
                
                return keys[nextIndex];
            },
            pageChange (page) {
                this.pages.current = page;
                this.scrollUp();
                this.fetchApartments();
            },
            pageSizeChage (size) {
                this.pages.size = size;
                this.fetchApartments();
            },
            formatRoomFilter (val) {
                return val + ' Zimmer';
            },
            formatSizeFilter (val) {
                return val + ' m²';
            },
            formatPriceFilter (val) {
                return val + '€';
            },
            scrollUp () {
                document.querySelector('.content').scrollTo(0, 0);
            },
            resetFilter () {
                this.pages.current = 1;
                
                this.filter.rooms.active = false;
                this.filter.price.active = false;
                this.filter.size.active = false;
                
                for(let property in this.filter.features.main) {
                    this.filter.features.main[property].active = false;
                }
                for(let property in this.filter.features.buildingState) {
                    this.filter.features.buildingState[property].active = false;
                }
                for(let property in this.filter.features.accessibility) {
                    this.filter.features.accessibility[property].active = false;
                }
                
                this.openFilters = ['daysToLookBack'];
                
                this.scrollUp();
                this.fetchApartments();
            },
            filterChange () {
                this.pages.current = 1;
                this.scrollUp();
                this.fetchApartments();
            },
            fetchApartments () {
                this.$Loading.start();
                
                let filter = {
                    params: {
                        page: this.pages.current,
                        limit: this.pages.size,
                        cityId: this.$route.params.cityId
                    }
                };
                
                // apply filter
                if (this.filter.rooms.active) {
                    filter.params.minRooms = this.filter.rooms.range[0];
                    filter.params.maxRooms = this.filter.rooms.range[1];
                }
                if (this.filter.price.active) {
                    filter.params.minPrice = this.filter.price.range[0];
                    filter.params.maxPrice = this.filter.price.range[1];
                }
                if (this.filter.size.active) {
                    filter.params.minSize = this.filter.size.range[0];
                    filter.params.maxSize = this.filter.size.range[1];
                }
                if (this.daysToLookBack !== 7) {
                    filter.params.days = this.daysToLookBack;
                }
                
                let features = [];
                for (let property in this.filter.features.main) {
                    if (this.filter.features.main[property].active) {
                        
                        features.push(this.filter.features.main[property].value);
                    }
                }
                for (let property in this.filter.features.buildingState) {
                    if (this.filter.features.buildingState[property].active) {
                        features.push(this.filter.features.buildingState[property].value);
                    }
                }
                for (let property in this.filter.features.accessibility) {
                    if (this.filter.features.accessibility[property].active) {
                        features.push(this.filter.features.accessibility[property].value);
                    }
                }
                
                if (this.filter.features.pets.active) {
                    features.push(this.filter.features.pets.value);
                }
                
                if (this.filter.features.flatSharingSuitable.active) {
                    features.push(this.filter.features.flatSharingSuitable.value);
                }

                // assemble feature string
                if (features.length) {
                    filter.params.features = features.join(',');
                }
                
                axios.get(`${config.apiUrl}/apartments`, filter)
                .then(response => {
                    this.apartments = response.data.docs;
                    this.pages.total = parseInt(response.data.total);
                    this.pages.current = parseInt(response.data.page);
                    
                    setTimeout(function () {
                        this.calculateMapBounds();
                        this.$Loading.finish();
                    }.bind(this), 500);

                })
                .catch(e => {
                    this.$Loading.error();
                    this.errors.push(e)
                })
            },
            fetchCities () {
                axios.get(`${config.apiUrl}/cities`)
                .then(response => {
                    let that = this;
                    
                    forEach(response.data.cities, function(value) {
                        if (!some(that.cities, {id: value.cityId})) {
                            that.cities.push({
                                id: value.cityId
                            });
                        }
                    });
                })
                .catch(e => {
                    this.errors.push(e)
                })
            },
            calculateMapBounds () {
                if (typeof google !== 'undefined') {
    
                    if (this.apartments.length) {
                        let bounds = new google.maps.LatLngBounds();
                        let hasBounds = false;
        
                        for (let i = 0; i < this.apartments.length; i++) {
                            let apt = this.apartments[i];
            
                            if (apt.location.lat && apt.location.lng) {
                                hasBounds = true;
                                bounds.extend(new google.maps.LatLng(apt.location.lat, apt.location.lng));
                            }
                        }
        
                        if (hasBounds) {
                            let WORLD_DIM = {height: 256, width: 256};
                            let ZOOM_MAX = 13;
            
                            let mapDim = {
                                height: window.innerHeight - 80,
                                width: document.querySelector(".map").offsetWidth
                            };
            
                            function latRad(lat) {
                                let sin = Math.sin(lat * Math.PI / 180);
                                let radX2 = Math.log((1 + sin) / (1 - sin)) / 2;
                                return Math.max(Math.min(radX2, Math.PI), -Math.PI) / 2;
                            }
            
                            function zoom(mapPx, worldPx, fraction) {
                                return Math.floor(Math.log(mapPx / worldPx / fraction) / Math.LN2);
                            }
            
                            let ne = bounds.getNorthEast();
                            let sw = bounds.getSouthWest();
            
                            let latFraction = (latRad(ne.lat()) - latRad(sw.lat())) / Math.PI;
            
                            let lngDiff = ne.lng() - sw.lng();
                            let lngFraction = ((lngDiff < 0) ? (lngDiff + 360) : lngDiff) / 360;
            
                            let latZoom = zoom(mapDim.height, WORLD_DIM.height, latFraction);
                            let lngZoom = zoom(mapDim.width, WORLD_DIM.width, lngFraction);
            
                            this.map.options.zoom = Math.min(latZoom, lngZoom, ZOOM_MAX);
                            this.map.center = bounds.getCenter();
                        }
                        else {
                            this.map.center = map.defaultCenter;
                        }
                    }
                    else {
                        this.map.center = map.defaultCenter;
                    }
                }
            },
            visitCity (cityId) {
                let url = this.$router.resolve({
                    name: 'city',
                    params: {
                        cityId: cityId
                    }
                });
                
                window.open(url.href, '_self');
            }
        },
        created() {
            this.fetchApartments();
            this.fetchCities();
        }
    }
</script>
